macroScript cmr4 category:"p3d"
(

	
undo off
(
		filename = getopenfilename \
						types: "All|*.*|"	
		--filename = ff
		if filename != undefined then
		(
			f = fopen filename "rb"	
			print f	
			fseek f 0 #seek_end
			filesize = ftell f
			fseek f 8 #seek_set	
			table_offset = readlong f
			print table_offset
			fseek f table_offset #seek_set
			object_count = readlong f
			aux = readlong f
			format "aux  : %\n" aux 			
			aux = readlong f
			format "aux  : %\n" aux 			
			aux = readlong f
			format "aux  : %\n" aux 
			
			back_pointer = readlong f
			format "back_pointer : %\n" back_pointer
			
			texture_table_offset = readlong f
			format "texture_table_offset : %\n" texture_table_offset
			
			texture_names_off_count = readlong f
			format "texture_names_off_count : %\n" texture_names_off_count
			
			aux = readlong f
			format "aux  : %\n" aux
			
			obj_chunks_count = readlong f
			format "obj_chunks_count : %\n" obj_chunks_count				

			obj_chunks_off_table_start = readlong f
			format "obj_chunks_off_table_start : %\n" obj_chunks_off_table_start	

			aux = readlong f
			format "aux  : %\n" aux	
			
			second_table_start = readlong f
			format "second_table_start : %\n" second_table_start			

			-- read chunks offsets
			--print "chunks offsets"
			chunks_array = #()
			fseek f obj_chunks_off_table_start #seek_set
			
			for i = 1 to obj_chunks_count do
			(				
				achunk = #()
				here = ftell f
				aoffset = readlong f
				atype = readlong f
				--format "%[%] -> offset: % , type: %\n" here i aoffset atype 
				append achunk aoffset	
				append achunk atype
				asize = 0
				append achunk asize
				append 	chunks_array achunk		
			)
/*
			for choindex = 1 to chunks_array.count-1 do
			(
				chnksize = chunks_array[choindex + 1][1] - chunks_array[choindex][1]				
				format "% -> offset: % , type: % , size: %\n" choindex  chunks_array[choindex][1] chunks_array[choindex][2] chnksize 
				chunks_array[choindex][3] = chnksize 				
			)
*/

format "\n"
prevfaceend = 0
			for cho in chunks_array do
			(
				if (cho[2] == 0) then
				(
					fseek f cho[1] #seek_set
					A = readlong f										
					B = readlong f	
					C = readlong f				
					--format "type 0 offset: % A: %    B: %   C: %\n" cho[1] A B C
					
				)
				
				if (cho[2] == 1) then
				(
					--fseek f cho[1] #seek_set
					--A = readlong f										
					--B = readlong f	
					--C = readlong f		
		
					--format "type 1 offset: %\n" cho[1] 
				)				
				if (cho[2] == 3) then
				(
					--read matrices 
					fseek f (cho[1]-480) #seek_set
					for mii = 1 to 4 do
					(
						afloat = readfloat f 
						for kk = 1 to 4 do
						( 
							afloat = readfloat f 
							afloat *= 1000
							--format "%   " afloat
						)
						--format "\n"
					)
					
					
					fseek f (cho[1]-256) #seek_set
					for kk = 1 to 3 do
					( 
						afloat = readfloat f 
						afloat *= 1000
						--format "%   " afloat
					)
					--format "\n"
					
					fseek f (cho[1]-240) #seek_set
					for kk = 1 to 3 do
					( 
						afloat = readfloat f 
						afloat *= 1000
						--format "%   " afloat
					)
					--format "\n"

					
					fseek f (cho[1]-416) #seek_set
					xpos = readfloat f
					xpos = xpos*1000
					
					zpos = readfloat f
					zpos = zpos*1000
					
					ypos = readfloat f
					ypos = ypos*1000
					
					
					
					------------------------------------------------------------
					fseek f cho[1] #seek_set
					--format "chunk: offset =  % , type: %\n"  cho[1] cho[2]

					
					fseek f (cho[1]+9*4) #seek_set	
				
					vertex_start = readlong f					
					--format "vertex_start: %\n" vertex_start
					
					face_start = readlong f
					--format "face_start: %\n" face_start
					face_data_size = (readlong f)*2
					--format "face_data_size: %\n" face_data_size
					
					vertex_data_size = face_start - vertex_start
					--format "vertex_data_size: %\n" vertex_data_size					

					fseek f vertex_start #seek_set
					vertex_start = readlong f	
					vertex_aux = readlong f				
					--format "vertex_start: %  vertex_aux: %\n" vertex_start vertex_aux
					
					fseek f face_start #seek_set	
					face_start = readlong f
					face_aux = readlong f
					--format "face_start: %  face_aux: %\n" face_start face_aux
					
					--rd fix
					/*
					fseek f (cho[1]+12*4) #seek_set
					face_data_size = (readlong f)*2
					format "face_data_size: %\n" face_data_size
					*/				
					vertex_count = vertex_data_size/36
					--format "vertex_count: %\n" vertex_count
					
					
					faceend = face_start + face_data_size
					--format "faceend %\n" faceend 
					
					bytescount = (cho[1] - prevfaceend )

				
					prevfaceend = faceend 
					
					verbose = false
					if (verbose) then
					(
						format "prevfaceend  %\n" prevfaceend 
						format "post bytes count %\n" bytescount 					
						
						format "\n"
						
						format "chunk: offset =  % , type: %\n"  cho[1] cho[2]
						
						format "vertex_start: %  vertex_aux: %\n" vertex_start vertex_aux
						format "vertex_data_size: %\n" vertex_data_size
						format "vertex_count: %\n" vertex_count
						
						format "face_start: %  face_aux: %\n" face_start face_aux
						format "face_data_size: %\n" face_data_size
						format "faceend %\n" faceend
					)
					
					
				
					--adatasize = (vertex_start - cho[1])/4
					/*
					for i = 0  to 240/4  do
					(
						fseek f (cho[1]+i*4) #seek_set
						here = ftell f
						auxl = readlong f
						if auxl != 0 then
						format "% : %\n" i auxl
					)
					*/
----------------------------------------------------------------------------------
					vertex_array =#()
					normal_array = #()
					uvarray = #()
					fseek f vertex_start #seek_set
					for vi = 1 to vertex_count do
					(
						x = readfloat f
						z = readfloat f
						y = readfloat f
						
						x = x*1000 + xpos
						y = y*1000 + ypos
						z = z*1000 + zpos
						append vertex_array [x,y,z]
						
						nx = readfloat f
						nz = readfloat f
						ny = readfloat f	
			
						append normal_array [nx,ny,nz] 
						
						color = readfloat f
						
						u = readfloat f
						v = 1 - readfloat f
						w = 0 
						
						append uvarray [u,v,w]						
										
					)--for v = 1 to vertex_count					
----------------------------------------------------------------------------------

					indices = #()
					-- read full face stream
					fd = 0
					index_count = face_data_size/2
					fseek f face_start #seek_set
					
					for fi = 1 to index_count  do
					(
						fd = readshort f
						fd += 1	
						append indices  [fd,fi]	
						--format "% -> %\n" fi fd
			
					)--for fi = 1 to (face_data_size/2) 
					
					face_array = #()
					for fi = 1 to index_count-2  do
					(
						fa = indices[fi][1]
						fb = indices[fi+1][1]
						fc = indices[fi+2][1]
						aface = [fa,fb,fc]							
						append face_array aface
					)					
					
--------------------------------------------------------------------------------------------------------------------------									
		/*			
					strip_offsets = #()
					strip_count = 1
					append strip_offsets 1
					indices[1][2] = 1
					
					for i = 1 to (index_count - 3) do
					(
						--format " % >> %\n" i indices[i]
						if ((indices[i][1] == indices[i+1][1]) and (indices[i][1] == indices[i+2][1])) then
						(
							append strip_offsets i
							indices[i][2] = 1
							strip_count += 1
						)
					)
					
					--print "strip_offsets" 
					--print strip_offsets
					
						
					for s = 1 to (strip_count-1) do
					(
						
						order = false
						if s == 1 then 
							k = 0
						else
							k = 3
						
						if s == (strip_count-1) then 
							l = 3
						else
							l = 2
						
						for i = strip_offsets[s]+k to strip_offsets[s+1]-l do 
						(
							
							--format "[%,%,%]\n" indices[i][1] indices[i+1][1] indices[i+2][1]
							if ((indices[i][1] != indices[i+1][1]) and (indices[i][1] != indices[i+2][1])and (indices[i+1][1] != indices[i+2][1])) then
							(
								--if (i == (strip_offsets[s]+k)) then
								--(
								--		append face_array [indices[i][1],indices[i+2][1],indices[i+1][1]]
								--		order = not order
								--) 
								--else
								--(
									if order  then
									(						
										append face_array [indices[i][1],indices[i+1][1],indices[i+2][1]]
										order = not order
									)
									else
									(
										append face_array [indices[i][1],indices[i+2][1],indices[i+1][1]]
										order = not order
									)
								--)
							)
							else
							(
		
								order = not order
							)
						)
						--print s
						--print face_array								
					)	
*/					
--------------------------------------------------------------------------------------------------------------------------

					
					aname = vertex_start as string
					
					--anode = mesh vertices:vertex_array faces:face_array	normals:normal_array name:aname		
					anode = mesh vertices:vertex_array faces:face_array	 name:aname									

					/*
					for fi = 1 to anode.numfaces do					
					(
						crtface = getface anode fi
						
						
						verta = getvert anode crtface[1]
						vertb = getvert anode crtface[2]
						vertc = getvert anode crtface[3]
						
						textx = (verta[1] + vertb[1] + vertc[1])/3
						texty = (verta[2] + vertb[2] + vertc[2])/3
						textz = (verta[3] + vertb[3] + vertc[3])/3
						atext = fi as string
						--textobj = text text:atext pos:[textx,texty,textz] size:10
						format "% -> %\n" fi crtface
					)	
					*/
					
					meshop.removeillegalfaces anode 
					meshop.removedegeneratefaces anode
					/*
					for fi = 1 to anode.numfaces do					
					(
						crtface = getface anode fi
						
						
						verta = getvert anode crtface[1]
						vertb = getvert anode crtface[2]
						vertc = getvert anode crtface[3]
						
						textx = (verta[1] + vertb[1] + vertc[1])/3
						texty = (verta[2] + vertb[2] + vertc[2])/3
						textz = (verta[3] + vertb[3] + vertc[3])/3
						atext = fi as string
						textobj = text text:atext pos:[textx,texty,textz] size:10
						format "% -> %\n" fi crtface
					)
					*/
					/*
					for vi = 1 to anode.numverts do				
					(												
						verta = getvert anode vi
						
						atext = vi as string
						textobj = text text:atext pos:verta size:10
						--format "% -> %\n" fi crtface
					)
					*/
					
					anode.numtverts = anode.numverts
					buildtvfaces anode 
					
					for vi = 1 to anode.numverts do
					(
						settvert anode vi uvarray[vi]
						--print uvarray[vi]
					)--for vi = 1 to vertcount do
					
					--format "anode.numfaces %\n" anode.numfaces
					
					allfaces = #()
					for fi = 1 to anode.numfaces do					
					(
						crtface = getface anode fi
						append allfaces crtface 
					)					
					
					for fi = 1 to anode.numfaces do
					(
						settvface anode fi allfaces[fi]	
					)--for fi = 1 to facecount		

			
	

/*
					textpos = [0,0,0]									
					for fi = 1 to anode.numfaces-2 do					
					(
						firstface = getface anode fi
						secondface = getface anode fi+1
						thirdface = getface anode fi+2
						
						if ( (firstface[3] == secondface[2]) and (secondface[2] == thirdface[1])) then
						(
							--format "% % %\n" firstface secondface thirdface 
							format "%\n" fi
						)
					)
*/					
					--format "facecount = %\n" anode.numfaces 
					
					allfaces = #()
					for fi = 1 to anode.numfaces do					
					(
						append allfaces fi
					)						
		
					meshop.unifynormals anode allfaces 
					
					
					--anode.pos = [xpos, ypos, zpos]
						
													
-------------------------------------------------------------------
-- matrices
/*
					fseek f (face_start + index_count*2 + 64) #seek_set
					
					for mati = 1 to 3  do
					(
						avector = #()
						for melem = 1 to 4 do
						(
							afloat =readfloat f
							append avector afloat
						)
						format "%\n" avector
					)--for fi = 1 to (face_data_size/2) 	
*/												
----------------------------------------------------------------------------------
/*
				choend = cho[1] + cho[3]
				format "choend  %\n" choend 
				faceend = face_start + face_data_size
				format "faceend %\n" faceend 
				bytescount = (cho[1] - prevfaceend )
				format "prevfaceend  %\n" prevfaceend 
				format "post bytes count %\n" bytescount 
			
				prevfaceend = faceend 
*/					


				)
			)
/*		
			-- read names offsets	
			print "names offsets"
			texture_offsets_array = #()
			fseek f texture_table_offset #seek_set
			for i = 1 to texture_names_off_count do
			(				
				here = ftell f
				aoffset = readlong f
				--format "%[%] -> offset: % \n" here i aoffset  
				append 	texture_offsets_array aoffset			
			)	
		
			for toff in texture_offsets_array do
			(
				fseek f toff #seek_set
				astring = readstring f
				--print astring
			)
*/	
-------------------------------------------------------------------

-- SECOND TABLE

			--table_offset
			--filesize
			acount = (filesize - table_offset)/4
			
			fseek f second_table_start #seek_set
			for st = 0 to acount-1 do
			(
				aoff = table_offset+st*4
				fseek f aoff #seek_set
				along = readlong f
				--format "% -> %: %\n" st aoff along 
			)
			

			
		)--if filename != undefined then

		)--undo off
		
		fclose f
		
	--)--for ff in files do
)	

/*
6R4
chunk: offset =  1360 , type: 3
vertex_start: 3244
face_start: 9016
face_data_size: 556
vertex_data_size: 5772
vertex_start: 3256  vertex_aux: 1
face_start: 9028  face_aux: 1
vertex_count: 160
1368:2
1372:1568
1376:3232
1392:3244
1396:9016
1400:278
1404:10
1552:2
1556:160
1568:1616
1572:1
1576:2280
1588:2304
1592:1
1596:3216
choend  1616
faceend 9584
post dword count -1992

1 -> offset: 1360 , type: 3 , size: 256
2 -> offset: 1616 , type: 0 , size: 432
3 -> offset: 2048 , type: 1 , size: 112
4 -> offset: 2160 , type: 1 , size: 144
5 -> offset: 2304 , type: 0 , size: 432
6 -> offset: 2736 , type: 1 , size: 112
7 -> offset: 2848 , type: 1 , size: 112
8 -> offset: 2960 , type: 1 , size: 112
9 -> offset: 3072 , type: 1 , size: 7040


346 -> 768728: 4
347 -> 768732: 628
348 -> 768736: 296
349 -> 768740: 964
350 -> 768744: 50996
351 -> 768748: 97460
352 -> 768752: 143924
353 -> 768756: 190404
354 -> 768760: 632
355 -> 768764: 9716
356 -> 768768: 960
357 -> 768772: 1172
358 -> 768776: 767400
--------------------------------------------------------------------------------------------------------
chunk: offset =  15200 , type: 3
vertex_start: 16384
face_start: 19744
face_data_size: 294
vertex_data_size: 3360
vertex_start: 16396  vertex_aux: 1
face_start: 19756  face_aux: 1
vertex_count: 93
15208:1
15212:15408
15216:16372
15232:16384
15236:19744
15240:147
15244:10
15392:1
15396:93
15408:15440
15412:1
15416:16356
choend  15440
faceend 20050
post dword count -1152

11 -> offset: 15200 , type: 3 , size: 240
12 -> offset: 15440 , type: 0 , size: 432
13 -> offset: 15872 , type: 1 , size: 112
14 -> offset: 15984 , type: 1 , size: 112
15 -> offset: 16096 , type: 1 , size: 112
16 -> offset: 16208 , type: 1 , size: 4384
17 -> offset: 20592 , type: 3 , size: 256
-------------------------------------------------------------------------------------------------------

chunk: offset =  412192 , type: 3
vertex_start: 413340
face_start: 417996
face_data_size: 410
vertex_data_size: 4656
vertex_start: 413352  vertex_aux: 1
face_start: 418008  face_aux: 1
vertex_count: 129
412200:1
412204:412400
412208:413328
412224:413340
412228:417996
412232:205
412236:10
412384:1
412388:129
412400:412432
412404:1
412408:413312
choend  412432
faceend 418418
post dword count -1496

60 -> offset: 412192 , type: 3 , size: 240
61 -> offset: 412432 , type: 0 , size: 432
62 -> offset: 412864 , type: 1 , size: 112
63 -> offset: 412976 , type: 1 , size: 112
64 -> offset: 413088 , type: 1 , size: 112
65 -> offset: 413200 , type: 1 , size: 5760
66 -> offset: 418960 , type: 3 , size: 2928

*/

